﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Send_Email_Attachments_MVC_Core.Models;
using Microsoft.AspNetCore.Mvc;

using System.IO;
using System.Net;
using System.Net.Mail;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;

namespace Send_Email_Attachments_MVC_Core.Controllers
{
    public class HomeController : Controller
    {
        public IConfiguration Configuration { get; set; }

        public HomeController(IConfiguration _configuration)
        {
            this.Configuration = _configuration;
        }

        // GET: Home
        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Index(EmailModel model)
        {
            string host = this.Configuration.GetValue<string>("Smtp:Server");
            int port = this.Configuration.GetValue<int>("Smtp:Port");
            bool enableSsl = this.Configuration.GetValue<bool>("Smtp:EnableSsl");
            bool defaultCredentials = this.Configuration.GetValue<bool>("Smtp:DefaultCredentials");

            using (MailMessage mm = new MailMessage(model.Email, model.To))
            {
                mm.Subject = model.Subject;
                mm.Body = model.Body;
                if (model.Attachments != null)
                {
                    foreach (IFormFile attachment in model.Attachments)
                    {
                        string fileName = Path.GetFileName(attachment.FileName);
                        mm.Attachments.Add(new Attachment(attachment.OpenReadStream(), fileName));
                    }
                }
                mm.IsBodyHtml = false;
                using (SmtpClient smtp = new SmtpClient())
                {
                    smtp.Host = host;
                    smtp.EnableSsl = enableSsl;
                    NetworkCredential networkCred = new NetworkCredential(model.Email, model.Password);
                    smtp.UseDefaultCredentials = defaultCredentials;
                    smtp.Credentials = networkCred;
                    smtp.Port = port;
                    smtp.Send(mm);
                    ViewBag.Message = "Email sent.";
                }
            }
            return View();
        }
    }
}